#! /usr/bin/env dcli

import 'dart:io';


import 'package:dcli/dcli.dart';
import 'package:dcli_scripts/dcli_scripts.dart';

/// dcli script generated by:
/// dcli create docker_push.dart
///
/// See
/// https://pub.dev/packages/dcli#-installing-tab-
///
/// For details on installing dcli.
///

void main(List<String> args) {
  final parser = ArgParser()..addFlag('fresh', help: 'Force a fresh git clone');

  late final ArgResults results;
  try {
    results = parser.parse(args);
  } on FormatException catch (e) {
    printerr(red(e.message));
    exit(1);
  }

  final fresh = results['fresh'] as bool;
  final projectRoot = DartProject.self.pathToProjectRoot;
  final dockerfilePath = join(projectRoot, 'resource', 'Dockerfile');

  dockerPublish(
      pathToDockerFile: dockerfilePath, repository: 'noojee', clone: fresh);

  // final tag = 'noojee/batman:$packageVersion';
  // const latest = 'noojee/batman:latest';

  // print(orange('Running git push to ensure latest version is available'));
  // 'git push'.run;

  // 'docker  build -t $tag -t $latest -f $dockerfilePath .'.run;
  // 'docker push noojee/batman:$packageVersion'.run;
  // 'docker push $tag'.run;
  // 'docker push $latest'.run;
}
